/*
This code was modified by Georges Hanna, 2018 Fab Academy, final project
The code was modified Based on the below codes : 

+ controlling  a servo motor by two push buttons
http://www.instructables.com/id/Servo-Controlled-by-Pushbuttons/ // 

+ LED Bar Graph
https://www.arduino.cc/en/Tutorial/BarGraph

*/

#include <SoftwareServo.h>          // The compatible servo library with Attiny44 
SoftwareServo myservo;                 // Create servo object to control a servo 

const int analogPin = 0;   // The pin that the potentiometer is attached to analog pin 0
const int ledCount = 4;    // The number of the led set I'll connect on my attiny44 

int ledPins[] = {
  2, 3, 4, 5
};   // An array of pin numbers to which LEDs are attached

const int S_buttonPin1 = 6;    // Assigning pin 6&7 to the 2 push buttons that control the servo  
const int S_buttonPin2 = 7;


int buttonState1 = 0;   // Assigning 0 value to  an int variable name buttonState1&2
int buttonState2 = 0;


int position = 0;     // Assigning 0 value to the servo position 

void setup() 
{ 
 // loop over the pin array and set them all to output:
 for (int thisLed = 0; thisLed < ledCount; thisLed++) {         
    pinMode(ledPins[thisLed], OUTPUT);
  } 
  
  myservo.attach(1);// Attaching the servo to pin 1
  
  pinMode(S_buttonPin1, INPUT);  // Set the 2 pushbottons as input 
  pinMode(S_buttonPin2,INPUT);   



  digitalWrite(1, LOW); // Assign 0 volts to the Servo so I doesn't move if no button is preesed.

} 

void loop() 
{
  buttonState1 = digitalRead(S_buttonPin1);     // Read the value of Servo button 1 and assign it to buttonState1
 
  buttonState2 = digitalRead(S_buttonPin2);     // Read the value of Servo button 2 and assign it to buttonState2
  
  if(buttonState1 ==HIGH && position < 270)     /* If buttonState1 is high & the position of the servo smaller than
                                                  270 do the following */

  {

    myservo.write(position++); // Incerase the value by 1 while buttonState1 is high (this will rotate the servo clock wise)
    SoftwareServo::refresh(); // Using refresh to keep the servo updated
    delay(5); // dalay is used to pause the program for the amount of time


  }

   if(buttonState2 == HIGH && position > 0) /* If buttonState2 is high & the position of the servo is larger than 0 then
                                                  do the following */ 
   
   {
      
      myservo.write(position--); // Derease the rotational value by 1 while buttonState2 is high  (this will rotate the servo anti clockwise) 
      SoftwareServo::refresh(); // Using refresh to keep the servo updated
      delay(5); // dalay is used to pause the program for the amount of time


    }
 int sensorReading = analogRead(analogPin);
                                                               // map the result to a range from 0 to the number of LEDs:
  int ledLevel = map(sensorReading, 0, 1023, 0, ledCount);

  // loop over the LED array:
  for (int thisLed = 0; thisLed < ledCount; thisLed++) {
                                                                // if the array element's index is less than ledLevel,
                                                                // turn the pin for this element on:
    if (thisLed < ledLevel) {
      digitalWrite(ledPins[thisLed], HIGH);
    }
                                                               // turn off all pins higher than the ledLevel:
    else {
      digitalWrite(ledPins[thisLed], LOW);
    }
  }
 
}

